-------------------------------------------------------------------------------
-- ElvUI Chat Tweaks By Lockslap (US, Bleeding Hollow)
-- <Borderline Amazing>, http://ba-guild.com
-- Based on functionality provided by Prat and/or Chatter
-------------------------------------------------------------------------------
local Module	= ElvUI_ChatTweaks:NewModule("Channel Notice Filter", "AceConsole-3.0", "AceHook-3.0", "AceEvent-3.0")
local L			= ElvUI_ChatTweaks.L
Module.name		= L["Channel Notice Filter"]

local db, options
local defaults = {
	profile = {
		joined	= true,
		left	= true,
		changed	= true,
	}
}

local function FilterChannelNotices(self, event, message)
	if db.joined and message:find("YOU_JOINED") then
		return true
	elseif db.left and message:find("YOU_LEFT") then
		return true
	elseif db.changed and message:find("YOU_CHANGED") then
		return true
	end
	return false
end

function Module:OnEnable()
	ChatFrame_AddMessageEventFilter("CHAT_MSG_CHANNEL_NOTICE", FilterChannelNotices)
end

function Module:OnDisable()
	ChatFrame_RemoveMessageEventFilter("CHAT_MSG_CHANNEL_NOTICE", FilterChannelNotices)
end

function Module:OnInitialize()
	self.db = ElvUI_ChatTweaks.db:RegisterNamespace("ChannelMessageFilter", defaults)
	db = self.db.profile
	Module.debug = ElvUI_ChatTweaks.db.profile.debugging
end

function Module:GetOptions()
	if not options then
		options = {
			join = {
				type	= "toggle",
				order	= 13,
				name	= L["Joined Channel"],
				desc	= L["Filter joined channel message."],
				get		= function() return db.join end,
				set		= function(_, value) db.join = value end,
			},
			left = {
				type	= "toggle",
				order	= 14,
				name	= L["Left Channel"],
				desc	= L["Filter left channel message."],
				get		= function() return db.left end,
				set		= function(_, value) db.left = value end,
			},
			changed = {
				type	= "toggle",
				order	= 15,
				name	= L["Changed Channel"],
				desc	= L["Filter changed channel message."],
				get		= function() return db.changed end,
				set		= function(_, value) db.changed = value end,
			},
		}
	end
	return options
end

function Module:Info()
	return L["Filters the channel notices."]
end